package es.uoc.mxpdroid.ihm;

import com.example.mxpdroid.R;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.support.v4.app.NavUtils;
import android.annotation.TargetApi;
import android.content.Intent;
import android.os.Build;

public class OrigActivity extends Activity {
	
	private double gpsLat, gpsLon, touchLat, touchLon;
	private double lat, lon;
	
	public static final String ORIG_LAT	=	"origLat";
	public static final String ORIG_LON	=	"origLon";
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_orig);
		// Show the Up button in the action bar.
		setupActionBar();
		
		//getting extra data from intent that started this current activity
		Intent sender = getIntent();
		gpsLat = sender.getDoubleExtra("gpsLat", 0.0);
		gpsLon = sender.getDoubleExtra("gpsLon", 0.0);
		touchLat = sender.getDoubleExtra("touchLat", 0.0);
		touchLon = sender.getDoubleExtra("touchLon", 0.0);
		
		//setting the data to the default mode of selection "touchScreen"
		EditText tmp = (EditText) this.findViewById(R.id.latOrigText);
		tmp.setText(Double.toString(touchLat));
		tmp = (EditText) this.findViewById(R.id.lonOrigText);
		tmp.setText(Double.toString(touchLon));
		
		lat = touchLat;
		lon = touchLon;
		
	}

	/**
	 * Set up the {@link android.app.ActionBar}, if the API is available.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB)
	private void setupActionBar() {
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
			getActionBar().setDisplayHomeAsUpEnabled(true);
		}
	}

//	@Override
//	public boolean onCreateOptionsMenu(Menu menu) {
//		// Inflate the menu; this adds items to the action bar if it is present.
//		getMenuInflater().inflate(R.menu.orig, menu);
//		return true;
//	}
//
//	@Override
//	public boolean onOptionsItemSelected(MenuItem item) {
//		switch (item.getItemId()) {
//		case android.R.id.home:
//			// This ID represents the Home or Up button. In the case of this
//			// activity, the Up button is shown. Use NavUtils to allow users
//			// to navigate up one level in the application structure. For
//			// more details, see the Navigation pattern on Android Design:
//			//
//			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
//			//
//			NavUtils.navigateUpFromSameTask(this);
//			return true;
//		}
//		return super.onOptionsItemSelected(item);
//	}
	
	public void showGPSdata(View vv){
		EditText tmp = (EditText) this.findViewById(R.id.latOrigText);
		tmp.setText(Double.toString(gpsLat));
		tmp = (EditText) this.findViewById(R.id.lonOrigText);
		tmp.setText(Double.toString(gpsLon));
	}
	
	public void showTouchdata(View vv){
		EditText tmp = (EditText) this.findViewById(R.id.latOrigText);
		tmp.setText(Double.toString(touchLat));
		tmp = (EditText) this.findViewById(R.id.lonOrigText);
		tmp.setText(Double.toString(touchLon));
	}
	
	public void calcRoute(View vv){
		//we need to sent this data to the main activity
		EditText tmp = (EditText) this.findViewById(R.id.latOrigText);
		lat = Double.parseDouble(tmp.getText().toString());
		tmp = (EditText) this.findViewById(R.id.lonOrigText);
		lon = Double.parseDouble(tmp.getText().toString());
		
		Intent intent = new Intent();
		intent.putExtra(OrigActivity.ORIG_LAT, lat);
		intent.putExtra(OrigActivity.ORIG_LON, lon);
		
		setResult(RESULT_OK, intent);
		finish();
	}
	
}
