package es.uoc.mxpdroid.ihm;

import com.example.mxpdroid.R;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.RadioButton;
import android.support.v4.app.NavUtils;
import android.annotation.TargetApi;
import android.content.Intent;
import android.os.Build;

public class PoiActivity extends Activity {
	
	private double destLat;
	private double destLon;
	private boolean anisotropicSurface;
	private int replace;
	private String namePOI;
	
	public static final String DEST_LAT		=	"dest_LAT";
	public static final String DEST_LON		=	"dest_LON";
	public static final String TYPE_SURFACE	=	"surface";
	public static final String REPLACE_TO	=	"replace";
	public static final String NAME_POI		=	"name";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_poi);
		// Show the Up button in the action bar.
		setupActionBar();
		
		Intent sender = getIntent();
		destLat = sender.getDoubleExtra(DEST_LAT, 0.0);
		destLon = sender.getDoubleExtra(DEST_LON, 0.0);
		
		//setting the data to the default mode of selection "touchScreen"
		EditText tmp = (EditText) this.findViewById(R.id.latDestText);
		tmp.setText(Double.toString(destLat));
		tmp = (EditText) this.findViewById(R.id.lonDestText);
		tmp.setText(Double.toString(destLon));
	}

	/**
	 * Set up the {@link android.app.ActionBar}, if the API is available.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB)
	private void setupActionBar() {
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
			getActionBar().setDisplayHomeAsUpEnabled(true);
		}
	}

//	@Override
//	public boolean onCreateOptionsMenu(Menu menu) {
//		// Inflate the menu; this adds items to the action bar if it is present.
//		getMenuInflater().inflate(R.menu.poi, menu);
//		return true;
//	}
//
//	@Override
//	public boolean onOptionsItemSelected(MenuItem item) {
//		switch (item.getItemId()) {
//		case android.R.id.home:
//			// This ID represents the Home or Up button. In the case of this
//			// activity, the Up button is shown. Use NavUtils to allow users
//			// to navigate up one level in the application structure. For
//			// more details, see the Navigation pattern on Android Design:
//			//
//			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
//			//
//			NavUtils.navigateUpFromSameTask(this);
//			return true;
//		}
//		return super.onOptionsItemSelected(item);
//	}
	
	public void newAccCost(View vv){
		anisotropicSurface = false;
		
		EditText et = (EditText) this.findViewById(R.id.latDestText);
		destLat = Double.parseDouble(et.getText().toString());
		et = (EditText) this.findViewById(R.id.lonDestText);
		destLon = Double.parseDouble(et.getText().toString());
		et = (EditText) this.findViewById(R.id.replaceText);
		replace = Integer.parseInt(et.getText().toString());
		et = (EditText) this.findViewById(R.id.kfactorText);
		namePOI = et.getText().toString();
		
		RadioButton rb = (RadioButton) this.findViewById(R.id.radioAnisotropic);
		if (rb.isChecked())
			anisotropicSurface = true;
		
		Intent intent = new Intent();
		intent.putExtra(PoiActivity.DEST_LAT, destLat);
		intent.putExtra(PoiActivity.DEST_LON, destLon);
		intent.putExtra(PoiActivity.TYPE_SURFACE, anisotropicSurface);
		intent.putExtra(PoiActivity.REPLACE_TO, replace);
		intent.putExtra(PoiActivity.NAME_POI, namePOI);
		
		setResult(RESULT_OK, intent);
		finish();
	}
}
